/**************************************************************************\
 *
 *  This file is part of the Coin 3D visualization library.
 *  Copyright (C) 1998-2003 by Systems in Motion. All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  version 2.1 as published by the Free Software Foundation. See the
 *  file LICENSE.LGPL at the root directory of the distribution for
 *  more details.
 *
 *  If you want to use Coin for applications not compatible with the
 *  LGPL, please contact SIM to acquire a Professional Edition license.
 *
 *  Systems in Motion, Teknobyen, Abels Gate 5, 7030 Trondheim, NORWAY
 *  http://www.sim.no support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
\**************************************************************************/

#ifndef COIN_SOGLLIGHTIDELEMENT_H
#define COIN_SOGLLIGHTIDELEMENT_H

#include <Inventor/elements/SoInt32Element.h>


class COIN_DLL_API SoGLLightIdElement : public SoInt32Element {
  typedef SoInt32Element inherited;

  SO_ELEMENT_HEADER(SoGLLightIdElement);
public:
  static void initClass(void);
protected:
  virtual ~SoGLLightIdElement();

public:
  virtual void init(SoState * state);

  virtual void push(SoState * state);
  virtual void pop(SoState * state,
                   const SoElement * prevTopElement);

  static int32_t increment(SoState * const state, SoNode * const node);
  static int32_t increment(SoState * const state);

  static int32_t get(SoState * const state);
  static int32_t getDefault();
  static int32_t getMaxGLSources();

protected:
  static int32_t maxGLSources;

};

#endif // !COIN_SOGLLIGHTIDELEMENT_H
