/**************************************************************************\
 *
 *  This file is part of the Coin 3D visualization library.
 *  Copyright (C) 1998-2003 by Systems in Motion. All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  version 2.1 as published by the Free Software Foundation. See the
 *  file LICENSE.LGPL at the root directory of the distribution for
 *  more details.
 *
 *  If you want to use Coin for applications not compatible with the
 *  LGPL, please contact SIM to acquire a Professional Edition license.
 *
 *  Systems in Motion, Teknobyen, Abels Gate 5, 7030 Trondheim, NORWAY
 *  http://www.sim.no support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
\**************************************************************************/

#ifndef COIN_SOTEXTUREQUALITYELEMENT_H
#define COIN_SOTEXTUREQUALITYELEMENT_H

#include <Inventor/elements/SoFloatElement.h>


class COIN_DLL_API SoTextureQualityElement : public SoFloatElement {
  typedef SoFloatElement inherited;

  SO_ELEMENT_HEADER(SoTextureQualityElement);
public:
  static void initClass(void);
protected:
  virtual ~SoTextureQualityElement();

public:
  virtual void init(SoState * state);
  static void set(SoState * const state, SoNode * const node,
                  const float quality);
  static void set(SoState * const state, const float quality);
  static float get(SoState * const state);
  static float getDefault(void);
};

#ifndef COIN_INTERNAL
#include <Inventor/elements/SoTextureOverrideElement.h>
#endif // COIN_INTERNAL

#endif // !COIN_SOTEXTUREQUALITYELEMENT_H
