/**************************************************************************\
 *
 *  This file is part of the Coin 3D visualization library.
 *  Copyright (C) 1998-2003 by Systems in Motion. All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  version 2.1 as published by the Free Software Foundation. See the
 *  file LICENSE.LGPL at the root directory of the distribution for
 *  more details.
 *
 *  If you want to use Coin for applications not compatible with the
 *  LGPL, please contact SIM to acquire a Professional Edition license.
 *
 *  Systems in Motion, Teknobyen, Abels Gate 5, 7030 Trondheim, NORWAY
 *  http://www.sim.no support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
\**************************************************************************/

#ifndef COIN_SOENGINEOUTPUTLIST_H
#define COIN_SOENGINEOUTPUTLIST_H

#include <Inventor/lists/SbList.h>

class SoEngineOutput;


class SoEngineOutputList : public SbList<SoEngineOutput *> {
public:
  SoEngineOutputList(void) : SbList<SoEngineOutput *>() { }
  SoEngineOutputList(const int sizehint) : SbList<SoEngineOutput *>(sizehint) { }
  SoEngineOutputList(const SoEngineOutputList & l) : SbList<SoEngineOutput *>(l) { }

  void set(const int index, SoEngineOutput * item) { (*this)[index] = item; }
};

#endif // !COIN_SOENGINEOUTPUTLIST_H
