/**************************************************************************\
 *
 *  This file is part of the Coin 3D visualization library.
 *  Copyright (C) 1998-2003 by Systems in Motion. All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public License
 *  version 2.1 as published by the Free Software Foundation. See the
 *  file LICENSE.LGPL at the root directory of the distribution for
 *  more details.
 *
 *  If you want to use Coin for applications not compatible with the
 *  LGPL, please contact SIM to acquire a Professional Edition license.
 *
 *  Systems in Motion, Teknobyen, Abels Gate 5, 7030 Trondheim, NORWAY
 *  http://www.sim.no support@sim.no Voice: +47 22114160 Fax: +47 22207097
 *
\**************************************************************************/

#ifndef COIN_SOPOLYGONOFFSET_H
#define COIN_SOPOLYGONOFFSET_H

#include <Inventor/nodes/SoSubNode.h>
#include <Inventor/fields/SoSFFloat.h>
#include <Inventor/fields/SoSFBitMask.h>
#include <Inventor/fields/SoSFBool.h>
#include <Inventor/elements/SoPolygonOffsetElement.h>


class COIN_DLL_API SoPolygonOffset : public SoNode {
  typedef SoNode inherited;

  SO_NODE_HEADER(SoPolygonOffset);

public:
  static void initClass(void);
  SoPolygonOffset(void);

  enum Style {
    FILLED = SoPolygonOffsetElement::FILLED,
    LINES = SoPolygonOffsetElement::LINES,
    POINTS = SoPolygonOffsetElement::POINTS
  };

  SoSFFloat factor;
  SoSFFloat units;
  SoSFBitMask styles;
  SoSFBool on;

  virtual void doAction(SoAction * action);
  virtual void callback(SoCallbackAction * action);
  virtual void GLRender(SoGLRenderAction * action);

protected:
  virtual ~SoPolygonOffset();
};

#endif // !COIN_SOPOLYGONOFFSET_H
